#include <cstdio>
#include <ctime>


void dump_header(const char *fnam)
{
    FILE *pf = fopen(fnam,"r");
    if (!pf)
    {
        printf("Could not open %s\n",fnam);
        return;
    }
    time_t t0;
    int type;
    int lheader;
    char header[128];
    sprintf(header,"*****");
    fread(&t0,sizeof(time_t),1,pf);
    fread(&type, sizeof(int), 1, pf);
    fread(&lheader, sizeof(int),1, pf);
    fread(header, 80,1,pf);
    
    printf("time: %s type %d header: %s\n",ctime(&t0), type, header);
    fclose(pf);
}


void fix_header(const char *fnam, int type, const char *hdr=0)
{
    const unsigned int lheader=80;
    char header[lheader];
    printf("Current header:\n");
    dump_header(fnam);
    
    FILE *pf = fopen(fnam,"r+");
    if (!pf)
    {
        printf("Could not open %s\n",fnam);
        return;
    }
    printf("seek rc=%d\n",fseek(pf, sizeof(time_t), SEEK_SET));
    printf("fwrite rc=%d\n",fwrite(&type,sizeof(int),1,pf));
    if (hdr)
    {
        printf("fwrite rc=%d\n",fwrite(&lheader,sizeof(int),1,pf));
        memset(header, 0, lheader);
        strcpy(header,hdr);
        printf("fwrite rc=%d\n",fwrite(hdr,lheader,1, pf));
    }
    fclose(pf);
    
    printf ("New header:\n");
    dump_header(fnam);
}
